function languageNameFromCode(code) {
	var nm = code;
	switch(code) {
		case "af": nm ="Afrikaans"; break;
		case "als": nm ="Alemannisch"; break;
		case "an": nm ="Aragonés"; break;
		case "ang": nm ="Englisc"; break;
		case "ar": nm ="العربية"; break;
		case "arz": nm ="مصرى (Maṣrī)"; break;
		case "ast": nm ="Asturianu"; break;
		case "az": nm ="Azərbaycan"; break;
		case "bar": nm ="Boarisch"; break;
		case "bat-smg": nm ="Žemaitėška"; break;
		case "bcl": nm ="Bikol"; break;
		case "be": nm ="Беларуская"; break;
		case "be-x-old": nm ="Беларуская (тарашкевіца)"; break;
		case "bg": nm ="Български"; break;
		case "bh": nm ="भोजपुरी"; break;
		case "br": nm ="Brezhoneg"; break;
		case "bs": nm ="Bosanski"; break;
		case "ca": nm ="Català"; break;
		case "ceb": nm ="Sinugboanong Binisaya"; break;
		case "co": nm ="Corsu"; break;
		case "cs": nm ="Čeština"; break;
		case "csb": nm ="Kaszëbsczi"; break;
		case "cv": nm ="Чăваш"; break;
		case "cy": nm ="Cymraeg"; break;
		case "da": nm ="Dansk"; break;
		case "de": nm ="Deutsch"; break;
		case "diq": nm ="Zazaki"; break;
		case "el": nm ="Ελληνικά"; break;
		case "en": nm ="English"; break;
		case "eo": nm ="Esperanto"; break;
		case "es": nm ="Español"; break;
		case "et": nm ="Eesti"; break;
		case "eu": nm ="Euskara"; break;
		case "fa": nm ="فارسی"; break;
		case "fi": nm ="Suomi"; break;
		case "fiu-vro": nm ="Võro"; break;
		case "fo": nm ="Føroyskt"; break;
		case "fr": nm ="Français"; break;
		case "frp": nm ="Arpitan"; break;
		case "fur": nm ="Furlan"; break;
		case "fy": nm ="Frysk"; break;
		case "ga": nm ="Gaeilge"; break;
		case "gan": nm ="贛語"; break;
		case "gd": nm ="Gàidhlig"; break;
		case "gl": nm ="Galego"; break;
		case "glk": nm ="گیلکی"; break;
		case "gn": nm ="Avañe'ẽ"; break;
		case "gu": nm ="ગુજરાતી"; break;
		case "gv": nm ="Gaelg"; break;
		case "haw": nm ="Hawai`i"; break;
		case "he": nm ="עברית"; break;
		case "hi": nm ="हिन्दी"; break;
		case "hif": nm ="Fiji Hindi"; break;
		case "hr": nm ="Hrvatski"; break;
		case "hsb": nm ="Hornjoserbsce"; break;
		case "ht": nm ="Krèyol ayisyen"; break;
		case "hu": nm ="Magyar"; break;
		case "hy": nm ="Հայերեն"; break;
		case "ia": nm ="Interlingua"; break;
		case "id": nm ="Bahasa Indonesia"; break;
		case "ie": nm ="Interlingue"; break;
		case "ilo": nm ="Ilokano"; break;
		case "io": nm ="Ido"; break;
		case "is": nm ="Íslenska"; break;
		case "it": nm ="Italiano"; break;
		case "ja": nm ="日本語"; break;
		case "jv": nm ="Basa Jawa"; break;
		case "ka": nm ="ქართული"; break;
		case "kk": nm ="Қазақша"; break;
		case "ko": nm ="한국어"; break;
		case "ksh": nm ="Ripoarisch"; break;
		case "ku": nm ="Kurdî / كوردی"; break;
		case "kv": nm ="Коми"; break;
		case "kw": nm ="Kernewek/Karnuack"; break;
		case "la": nm ="Latina"; break;
		case "lad": nm ="Dzhudezmo"; break;
		case "lb": nm ="Lëtzebuergesch"; break;
		case "li": nm ="Limburgs"; break;
		case "lij": nm ="Líguru"; break;
		case "lmo": nm ="Lumbaart"; break;
		case "ln": nm ="Lingala"; break;
		case "lt": nm ="Lietuvių"; break;
		case "lv": nm ="Latviešu"; break;
		case "map-bms": nm ="Basa Banyumasan"; break;
		case "mg": nm ="Malagasy"; break;
		case "mi": nm ="Māori"; break;
		case "mk": nm ="Македонски"; break;
		case "mn": nm ="Монгол"; break;
		case "mr": nm ="मराठी"; break;
		case "ms": nm ="Bahasa Melayu"; break;
		case "mt": nm ="Malti"; break;
		case "mzn": nm ="مَزِروني"; break;
		case "nah": nm ="Nāhuatl"; break;
		case "nap": nm ="Nnapulitano"; break;
		case "nds": nm ="Plattdüütsch"; break;
		case "nds-nl": nm ="Nedersaksisch"; break;
		case "ne": nm ="नेपाली"; break;
		case "new": nm ="नेपाल भाषा"; break;
		case "nl": nm ="Nederlands"; break;
		case "nn": nm ="Nynorsk"; break;
		case "no": nm ="Norsk (Bokmål)"; break;
		case "nov": nm ="Novial"; break;
		case "nrm": nm ="Nouormand/Normaund"; break;
		case "oc": nm ="Occitan"; break;
		case "os": nm ="Иронау"; break;
		case "pa": nm ="ਪੰਜਾਬੀ"; break;
		case "pag": nm ="Pangasinan"; break;
		case "pam": nm ="Kapampangan"; break;
		case "pdc": nm ="Deitsch"; break;
		case "pi": nm ="पाऴि"; break;
		case "pl": nm ="Polski"; break;
		case "pms": nm ="Piemontèis"; break;
		case "ps": nm ="پښتو"; break;
		case "pt": nm ="Português"; break;
		case "qu": nm ="Runa Simi"; break;
		case "rm": nm ="Rumantsch"; break;
		case "ro": nm ="Română"; break;
		case "roa-rup": nm ="Armãneashce"; break;
		case "roa-tara": nm ="Tarandíne"; break;
		case "ru": nm ="Русский"; break;
		case "sa": nm ="संस्कृतम्"; break;
		case "sah": nm ="Саха тыла"; break;
		case "sc": nm ="Sardu"; break;
		case "scn": nm ="Sicilianu"; break;
		case "sco": nm ="Scots"; break;
		case "se": nm ="Sámegiella"; break;
		case "sh": nm ="Српскохрватски"; break;
		case "simple": nm ="Simple English"; break;
		case "sk": nm ="Slovenčina"; break;
		case "sl": nm ="Slovenščina"; break;
		case "sq": nm ="Shqip"; break;
		case "sr": nm ="Српски / Srpski"; break;
		case "stq": nm ="Seeltersk"; break;
		case "su": nm ="Basa Sunda"; break;
		case "sv": nm ="Svenska"; break;
		case "sw": nm ="Kiswahili"; break;
		case "szl": nm ="Ślůnski"; break;
		case "ta": nm ="தமிழ்"; break;
		case "tg": nm ="Тоҷикӣ"; break;
		case "th": nm ="ไทย"; break;
		case "tk": nm ="تركمن / Туркмен"; break;
		case "tl": nm ="Tagalog"; break;
		case "to": nm ="faka Tonga"; break;
		case "tr": nm ="Türkçe"; break;
		case "tt": nm ="Tatarça / Татарча"; break;
		case "ug": nm ="Oyghurque"; break;
		case "uk": nm ="Українська"; break;
		case "ur": nm ="اردو"; break;
		case "uz": nm ="O‘zbek"; break;
		case "vec": nm ="Vèneto"; break;
		case "vi": nm ="Tiếng Việt"; break;
		case "vls": nm ="West-Vlams"; break;
		case "vo": nm ="Volapük"; break;
		case "wa": nm ="Walon"; break;
		case "war": nm ="Winaray"; break;
		case "wuu": nm ="吴语"; break;
		case "yi": nm ="ייִדיש"; break;
		case "yo": nm ="Yorùbá"; break;
		case "zh": nm ="中文"; break;
		case "zh-classical": nm ="古文 / 文言文"; break;
		case "zh-min-nan": nm ="Bân-lâm-gú"; break;
		case "zh-yue": nm ="粵語"; break;
	}
	return nm;
}